
Require Import syntax.
Require Import nbe_cbv_atomic.
(* Require Import nbe_cbn_atomic. *)

Set Implicit Arguments.
Unset Strict Implicit.

Parameter a:atoms.

Definition nbe_v := nbe_cbv_atomic.Completeness.NbE.
(* Definition nbe_n := nbe_cbn_atomic.Completeness.NbE. *)

Check nbe_v.

(* Definition NbE {A} : proof nil false A -> bare * bare := fun p => (forget_proof (forget_nf (nbe_v p)) , forget_proof (forget_nf (nbe_n p))). *)
Definition NbE {A} : proof nil false A -> bare := fun p => forget_proof (forget_nf (nbe_v p)).

(** Some tests of the normalization algorithm *)

Definition id8 : proof nil false  (Func Nat (Func Nat Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply Shift.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id8).
Eval compute in (NbE id8).

Definition id9 : proof nil false (Func Nat Nat).
Proof.
  apply Lam.
  apply Reset.
  apply App with Nat.
  apply Lam.
  apply Hyp.
  apply Shift.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id9).
Eval compute in (NbE id9).

Definition id10 : proof nil false (Func Nat Nat).
Proof.
  apply Lam.
  apply Reset.
  apply Reset.
  apply Reset.
  apply App with Nat.
  apply Lam.
  apply Hyp.
  apply Shift.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id10).
Eval compute in (NbE id10).

Definition id11 : proof nil false (Func (Func Nat Nat) (Func Nat Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply Reset.
  apply App with Nat.
  apply Wkn.
  apply Hyp.
  apply Hyp.
Defined.

Eval compute in (forget_proof id11).
Eval compute in (NbE id11).

Definition id13 : proof nil false (Func (Func Nat Nat) (Func Nat Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply App with Nat.
  apply Wkn.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id13).
Eval compute in (NbE id13).

Definition id14 : proof nil false (Func (Func Nat Nat) (Func Nat Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply App with Nat.
  apply Wkn.
  apply Hyp.
  apply Reset.
  apply App with Nat.
  apply Wkn.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id14).
Eval compute in (NbE id14).

Definition id16 : proof nil false (Func (Func Nat Nat) (Func (Func Nat (Func Nat Nat)) (Func Nat Nat))).
Proof.
  apply Lam.
  apply Lam.
  apply Lam.
  apply Reset.
  apply App with Nat.
  apply Wkn.
  apply Wkn.
  apply Hyp.
  apply Reset.
  apply App with Nat.
  apply App with Nat.
  apply Wkn.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id16).
Eval compute in (NbE id16).

Definition id19 : proof nil false 
  (Func (Func Nat Nat)
       (Func (Func Nat Nat)
            (Func (Func Nat Nat) (Func Nat Nat)))).
Proof.
  apply Lam.
  apply Lam.
  apply Lam.
  apply Lam.
  apply Reset.
  apply App with Nat.
  apply Wkn.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof id19).
Eval compute in (NbE id19).

Definition id21 : proof nil false (Func (Sum Nat Nat) (Func Nat Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply Case with Nat Nat.
  apply Wkn.
  apply Hyp.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Hyp.
  apply Hyp.
Defined.

Eval compute in (forget_proof id21).
Eval vm_compute in (NbE id21).

(* (** Implicational version of DNS *) *)
(* Definition test_DNS : proof nil false  *)
(*   (Func *)
(*     (Func (Atom a) (Func (Func (Atom a) Nat) Nat)) *)
(*     (Func (Func (Func (Atom a) (Atom a)) Nat) Nat)). *)
(* Proof. *)
(*   apply Lam. *)
(*   apply Lam. *)
(*   apply Reset. *)
(*   apply App with (Func (Atom a) (Atom a)). *)
(*   apply Hyp. *)
(*   apply Lam. *)
(*   apply Shift. *)
(*   apply App with (Func (Atom a) Nat). *)
(*   apply App with (Atom a). *)
(*   apply Wkn. *)
(*   apply Wkn. *)
(*   apply Wkn. *)
(*   apply Hyp. *)
(*   apply Wkn. *)
(*   apply Hyp. *)
(*   apply Hyp. *)
(* Defined. *)

(* Eval compute in (forget_proof test_DNS). *)
(* Eval vm_compute in (NbE test_DNS). *)

(** Now some tests with numbers *)

Definition test22 : proof nil false Nat.
Proof.
  apply Zero.
Defined.

Eval compute in (forget_proof test22).
Eval compute in (NbE test22).

Definition test23 : proof nil false (Func Nat Nat).
Proof.
  apply Lam.
  apply Reset.
  apply Zero.
Defined.

Eval compute in (forget_proof test23).
Eval compute in (NbE test23).

Definition test24 : proof nil false (Func Nat Nat).
Proof.
  apply Lam.
  apply Reset.
  apply Shift.
  apply Zero.
Defined.

Eval compute in (forget_proof test24).
Eval compute in (NbE test24).

Definition test25 : proof nil false (Func Nat Nat).
Proof.
  apply Lam.
  apply Reset.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply App with Nat.
  apply Hyp.
  apply Zero.
Defined.

Eval compute in (forget_proof test25).
Eval compute in (NbE test25).

Definition test26 : proof nil false (Func Nat (Func (Func Nat (Func Nat Nat)) Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Rec.
  apply Zero.
  apply Wkn.
  apply Hyp.
  apply Hyp.
Defined.

(* Parameter A:formula. *)

(** This is blocking becaus A is a paramter, to investigate futher... *)
(* Definition test26 : proof nil false (Func A (Func (Func Nat (Func A A)) A)). *)
(* Proof. *)
(*   apply Lam. *)
(*   apply Lam. *)
(*   apply Rec. *)
(*   apply Zero. *)
(*   apply Wkn. *)
(*   apply Hyp. *)
(*   apply Hyp. *)
(* Defined. *)

Eval compute in (forget_proof test26).
Eval compute in (NbE test26).

Definition test27 : proof nil false (Func Nat (Func (Func Nat (Func Nat Nat)) Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Rec.
  apply Succ.
  apply Succ.
  apply Zero.
  apply Wkn.
  apply Hyp.
  apply Hyp.
Defined.

Eval compute in (forget_proof test27).
Eval compute in (NbE test27).

(* The same test but under a reset *)
Definition test28 : proof nil false (Func Nat (Func (Func Nat (Func Nat Nat)) Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply Shift.
  apply App with Nat.
  apply Hyp.
  apply Rec.
  apply Succ.
  apply Succ.
  apply Zero.
  apply App with Nat.
  apply Hyp.
  apply Wkn.
  apply Wkn.
  apply Hyp.
  apply Wkn.
  apply Hyp.
Defined.

Eval compute in (forget_proof test28).
Eval compute in (NbE test28).

(* *)
Definition test29 : proof nil false (Func Nat (Func (Func Nat (Func Nat Nat)) Nat)).
Proof.
  apply Lam.
  apply Lam.
  apply Reset.
  apply Rec.
  apply Shift.
  apply Succ.
  apply Succ.
  apply Zero.
  apply Wkn.
  apply Hyp.
  apply Hyp.
Defined.

Eval compute in (forget_proof test29).
Eval compute in (NbE test29).

